#pragma once

#include <cstdint>
#include <vector>

#include "IDArray.h"

namespace VectorDB {

/**
 * @brief Result returned by MilvusClient::Insert() and MilvusClient::Delete()
 */
class DmlResults {
public:
    /**
     * @brief The id array for entities which are inserted or deleted.
     */
    const IDArray& IdArray() const;

    /**
     * @brief Set the id array.
     */
    void SetIdArray(const IDArray& id_array);

    /**
     * @brief Set the id array.
     */
    void SetIdArray(IDArray&& id_array);

    /**
     * @brief The operation timestamp marked by server side.
     */
    uint64_t Timestamp() const;

    /**
     * @brief Set operation timestamp.
     */
    void SetTimestamp(uint64_t timestamp);

private:
    IDArray id_array_{std::vector<int64_t>{}};
    uint64_t timestamp_{0};
};

}  // namespace VectorDB
