#pragma once

#include <string>
#include <vector>

#include "FieldData.h"

namespace VectorDB {

/**
 * @brief Results returned by MilvusClient::Query().
 */
class QueryResults {
public:
    QueryResults();

    /**
     * @brief Constructor
     */
    explicit QueryResults(const std::vector<FieldDataPtr>& output_fields);

    /**
     * @brief Constructor
     */
    explicit QueryResults(std::vector<FieldDataPtr>&& output_fields);

    /**
     * @brief Get output field data by name.
     */
    FieldDataPtr GetFieldByName(const std::string& name);

    /**
     * @brief Get all output fields data.
     */
    const std::vector<FieldDataPtr>& OutputFields() const;

private:
    std::vector<FieldDataPtr> output_fields_;
};

}  // namespace VectorDB
